> ## Documentation Index
> Fetch the complete documentation index at: https://developers.fireblocks.com/llms.txt
> Use this file to discover all available pages before exploring further.

<AgentInstructions>

## Submitting Feedback

If you encounter incorrect, outdated, or confusing documentation on this page, submit feedback:

POST https://developers.fireblocks.com/feedback

```json
{
  "path": "/api-reference/cosigners-beta/add-cosigner",
  "feedback": "Description of the issue"
}
```

Only submit feedback when you have something specific and actionable to report.

</AgentInstructions>

# Add cosigner

> Add a new cosigner. The cosigner will be pending pairing until the API key is manually paired
Endpoint Permission: Admin and Non-Signing Admin.



## OpenAPI

````yaml https://docs.fireblocks.com/api/v1/swagger.yaml post /cosigners
openapi: 3.0.0
info:
  title: Fireblocks API
  description: >
    Fireblocks provides a suite of applications to manage digital asset
    operations and a complete development platform to build your business on the
    blockchain.


    - Visit our website for more information: [Fireblocks
    Website](https://fireblocks.com)

    - Visit our developer docs: [Fireblocks
    DevPortal](https://developers.fireblocks.com)
  version: 1.6.2
  contact:
    email: developers@fireblocks.com
servers:
  - url: https://api.fireblocks.io/v1
    description: Fireblocks Production Environment Base URL
  - url: https://sandbox-api.fireblocks.io/v1
    description: Fireblocks Sandbox Environment Base URL
security: []
paths:
  /cosigners:
    post:
      tags:
        - Cosigners (Beta)
      summary: Add cosigner
      description: >-
        Add a new cosigner. The cosigner will be pending pairing until the API
        key is manually paired

        Endpoint Permission: Admin and Non-Signing Admin.
      operationId: addCosigner
      parameters:
        - $ref: '#/components/parameters/X-Idempotency-Key'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AddCosignerRequest'
      responses:
        '201':
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
          description: Pending cosigner added
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AddCosignerResponse'
        default:
          $ref: '#/components/responses/Error'
      x-codeSamples:
        - lang: TypeScript
          source: >-
            const response: Promise<FireblocksResponse<AddCosignerResponse>> =
            fireblocks.cosignersBeta.addCosigner(cosignersBetaApiAddCosignerRequest);
        - lang: Java
          source: >-
            CompletableFuture<ApiResponse<AddCosignerResponse>> response =
            fireblocks.cosignersBeta().addCosigner(addCosignerRequest,
            idempotencyKey);
        - lang: Python
          source: >-
            response =
            fireblocks.cosigners_beta.add_cosigner(add_cosigner_request,
            idempotency_key);
components:
  parameters:
    X-Idempotency-Key:
      name: Idempotency-Key
      in: header
      description: >-
        A unique identifier for the request. If the request is sent multiple
        times with the same idempotency key, the server will return the same
        response as the first request. The idempotency key is valid for 24
        hours.
      required: false
      schema:
        type: string
  schemas:
    AddCosignerRequest:
      type: object
      properties:
        apiKeyId:
          type: string
          description: The id of the API key to be paired with the cosigner
          example: 123e4567-e89b-12d3-a456-426614174000
          format: uuid
        name:
          type: string
          description: The name of the cosigner
          example: My Cosigner 1
          minLength: 1
        existingCosigner:
          type: boolean
          description: Whether the cosigner already exists in another workspace
          default: false
          example: false
      required:
        - apiKeyId
        - name
    AddCosignerResponse:
      type: object
      properties:
        apiKeyId:
          type: string
          description: The id of the API key to be paired with the cosigner
          example: 123e4567-e89b-12d3-a456-426614174000
          format: uuid
        name:
          type: string
          description: The name of the cosigner
          example: My Cosigner 1
          minLength: 1
        existingCosigner:
          type: boolean
          description: Whether the cosigner already exists in another workspace
          default: false
          example: false
        pendingCosignerId:
          type: string
          description: The unique identifier of a pending cosigner
          example: 44fcead0-7053-4831-a53a-df7fb90d440f
          format: uuid
      required:
        - apiKeyId
        - name
        - pendingCosignerId
    ErrorSchema:
      type: object
      properties:
        message:
          type: string
        code:
          type: number
  headers:
    X-Request-ID:
      schema:
        type: string
      description: >-
        Unique ID correlated to the API request. Please provide it in any
        support ticket you create or on Github issues related to Fireblocks SDKs
  responses:
    Error:
      description: Error Response
      headers:
        X-Request-ID:
          $ref: '#/components/headers/X-Request-ID'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorSchema'

````